<template>
  <div class="flex flex-col justify-center py-12 sm:px-6 lg:px-8">
    <div class="sm:mx-auto sm:w-full sm:max-w-md">
      <img class="mx-auto h-12 w-auto" src="https://tailwindui.com/img/logos/workflow-mark-indigo-500.svg" alt="Workflow">
      <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
        Sign in to your account
      </h2>
      <p class="mt-2 text-center text-sm text-gray-600 max-w">
        Or
        <router-link to="/register" class="font-medium text-yellow-500 hover:text-yellow-500">register</router-link>
      </p>
    </div>

    <div class="mt-8 sm:mx-auto sm:w-full sm:max-w-md">
      <div class="bg-white py-8 px-4 shadow sm:rounded-lg sm:px-10">
        <VumikForm v-model="formData" @submit="tryLogin()" class="space-y-6">
          <div>
            <label for="email" class="text-left block text-sm font-medium text-gray-700">
              Email address
            </label>
            <div class="mt-1">
              <VumikInput type="email" name="email" />
            </div>
          </div>

          <div>
            <label for="password" class="text-left block text-sm font-medium text-gray-700">
              Password
            </label>
            <div class="mt-1">
              <VumikInput type="password" name="password" />
            </div>
          </div>

          <div>
            <VumikInput type="submit" value="Login" />
          </div>
        </VumikForm>

      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'

export default {
  name: 'Login',
  data () {
    return {
      formData: {
        email: '',
        password: ''
      },
      prevRoute: null,
      error: undefined
    }
  },
  beforeRouteEnter (to, from, next) {
    next(vm => { vm.prevRoute = from })
  },
  computed: mapGetters('auth', ['isLoggedIn']),
  beforeMount () {
    if (this.isLoggedIn) {
      this.$router.push('/dashboard')
    }
  },
  methods: {
    tryLogin () {
      this.login(this.formData).then(() => this.$router.push(this.prevRoute ? this.prevRoute : '/dashboard')).catch(e => { this.error = e.message })
    },
    ...mapActions('auth', ['login'])
  }
}
</script>
